\version "2.18.2"
\paper {
  top-system-spacing =
  #'((basic-distance . 15 )
  (minimum-distance . 15 )
  (padding . 0 )
  (stretchability . 0))

  #(set-paper-size "a4" 'portrait)
  system-system-spacing =
  #'((basic-distance . 24)
  (minimum-distance . 24)
  (padding . 0)
  (stretchability . 0))
  
  min-systems-per-page = 8
  max-systems-per-page = 8
  
  print-page-number = ##t
  oddHeaderMarkup = \markup \fill-line { " " }
  evenHeaderMarkup = \markup \fill-line { " " }
  oddFooterMarkup = \markup {
  \fill-line {
  \on-the-fly #not-first-page 
  \concat { 
  "-"
      \fontsize #1.5
      \on-the-fly #print-page-number-check-first
      \fromproperty #'page:page-number-string
   "-"
      }
    }
  }
  evenFooterMarkup = \markup {
  \on-the-fly #not-first-page 
    \fill-line {
  \concat { 
  "-"
      \fontsize #1.5
      \on-the-fly #print-page-number-check-first
      \fromproperty #'page:page-number-string
   "-"
      }
    }
  }
}
\header {
  title = \markup { \normal-text \italic {ostinato and interrupt}}
  piece = "guitar/all"
  opus = \markup { \concat {"version generated: "} #(strftime "%Y.%m.%d" (localtime (current-time)))}
  composer = "michael winter (mexico city, mx; 2017)"
  tagline = ""
} 
#(set-global-staff-size 16)
\layout {
  indent = 0.0\cm
  ragged-right = ##t
  \context {
    \Staff
      \override StaffSymbol.line-count = #6
      \override StaffSymbol.staff-space = #1.8
      \override Beam.positions = #'(-5 . -5)
      \override Stem.direction = #DOWN
      \override Stem.stemlet-length = #1
      \override Beam.breakable = ##t
      \remove "Clef_engraver"
      \remove "Time_signature_engraver"
    }
}

#(define-public ((color-staff-lines . rest) grob)

   (define (index-cell cell dir)
     (if (equal? dir RIGHT)
         (cdr cell)
         (car cell)))

   (define (index-set-cell! x dir val)
     (case dir
       ((-1) (set-car! x val))
       ((1) (set-cdr! x val))))

   (let* ((common (ly:grob-system grob))
          (span-points '(0 . 0))
          (thickness (* (ly:grob-property grob 'thickness 1.0)
                        (ly:output-def-lookup (ly:grob-layout grob) 'line-thickness)))
          (width (ly:grob-property grob 'width))
          (line-positions (ly:grob-property grob 'line-positions))
          (staff-space (ly:grob-property grob 'staff-space 1))
          (line-stencil #f)
          (total-lines empty-stencil)
          ;; use a local copy of colors list, since
          ;; stencil creation mutates list
          (colors rest))

     (for-each
      (lambda (dir)
        (if (and (= dir RIGHT)
                 (number? width))
            (set-cdr! span-points width)
            (let* ((bound (ly:spanner-bound grob dir))
                   (bound-ext (ly:grob-extent bound bound X)))
              
              (index-set-cell! span-points dir
                               (ly:grob-relative-coordinate bound common X))
              (if (and (not (ly:item-break-dir bound))
                       (not (interval-empty? bound-ext)))
                  (index-set-cell! span-points dir 
                                   (+ (index-cell span-points dir)
                                      (index-cell bound-ext dir))))))
        (index-set-cell! span-points dir (- (index-cell span-points dir)
                                            (* dir thickness 0.5))))
      (list LEFT RIGHT))

     (set! span-points
           (coord-translate span-points
                            (- (ly:grob-relative-coordinate grob common X))))
     (set! line-stencil
           (make-line-stencil thickness (car span-points) 0 (cdr span-points) 0))

     (if (pair? line-positions)
         (for-each (lambda (position)
                     (let ((color (if (pair? colors)
                                      (car colors)
                                      #f)))
                       (set! total-lines
                             (ly:stencil-add
                              total-lines
                              (ly:stencil-translate-axis
                               (if (color? color)
                                   (ly:stencil-in-color line-stencil
                                                        (first color)
                                                        (second color)
                                                        (third color))
                                   line-stencil)
                               (* position staff-space 0.5) Y)))
                       (and (pair? colors)
                            (set! colors (cdr colors)))))
                   line-positions)       
         (let* ((line-count (ly:grob-property grob 'line-count 5))
                (height (* (1- line-count) (/ staff-space 2))))
           (do ((i 0 (1+ i)))                      
               ((= i line-count))
             (let ((color (if (and (pair? colors)
                                   (> (length colors) i))
                              (list-ref colors i)
                              #f)))
               (set! total-lines (ly:stencil-add
                                  total-lines
                                  (ly:stencil-translate-axis
                                   (if (color? color)
                                       (ly:stencil-in-color line-stencil
                                                            (first color)
                                                            (second color)
                                                            (third color))
                                       line-stencil)
                                   (- height (* i staff-space)) Y)))))))
     total-lines))

#(define-public (bracket-stencils grob)
  (let ((lp (grob-interpret-markup grob (markup #:fontsize 3.5 #:translate (cons -0.3 -0.5) "[")))
        (rp (grob-interpret-markup grob (markup #:fontsize 3.5 #:translate (cons -0.3 -0.5) "]"))))
    (list lp rp)))

bracketify = #(define-music-function (parser loc arg) (ly:music?)
   (_i "Tag @var{arg} to be parenthesized.")
#{
  \once \override ParenthesesItem.stencils = #bracket-stencils
  \parenthesize $arg
#})

{
  \new Score 
  \with {
    \remove "Bar_number_engraver"
    proportionalNotationDuration = #(ly:make-moment 1 16)
  }
  <<
  \new Staff
  \with { 
    \remove "Stem_engraver"
  }
  << \repeat unfold 77 { \repeat unfold 59 { s16 \noBreak } s16 \break } \time 60/16 { \override Staff.Rest #'transparent = ##t  \bar "||"  \mark \markup{ \fontsize #-2 "0'12\"" }  \override Staff.Stem #'transparent = ##t \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "0'24\"" } s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 a'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "0'36\"" } s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } d'16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 a'16 s16 s16 s16 \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16  \mark \markup{ \fontsize #-2 "0'48\"" } a'16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16 c''16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16 s16 s16 c''16 s16 s16 s16 a'16 s16  \mark \markup{ \fontsize #-2 "1'00\"" } \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16 s16 s16 s16 s16 a'16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 \bracketify d'16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "1'12\"" } s16 s16 d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 d'16 s16 s16 s16  \mark \markup{ \fontsize #-2 "1'24\"" } \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "1'28\"" }  \override Staff.Stem #'transparent = ##f a'16  _3  [ r16 r16 g''16  _1  ] a'16  [ c''16 g''16 \harmonic  f'16 \harmonic   ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16  \mark \markup{ \fontsize #-2 "1'36\"" } s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "1'48\"" } \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 s16 s16 f'16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } d'16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "2'00\"" } f'16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } d'16 s16 s16 s16 a'16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "2'04\"" }  \override Staff.Stem #'transparent = ##f a'16 \harmonic  _1  [  g''16  _2 r16 f'16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t \bracketify d'16 s16 a'16 s16 s16 s16 d'16 s16 d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "2'12\"" } \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "2'24\"" } a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16 s16 s16  \mark \markup{ \fontsize #-2 "2'36\"" } s16 s16 s16 s16 s16 s16 c''16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "2'44\"" }  \override Staff.Stem #'transparent = ##f a'16 \harmonic  _2  [  r16 e''16  _3 r16  ] r16  [ d'16 \harmonic  _2  r16 a'16 \harmonic   ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t f'16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "2'48\"" } s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } d'16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 a'16 s16 s16 s16  \mark \markup{ \fontsize #-2 "3'00\"" } a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \bracketify d'16 s16 s16 s16 f'16 s16 s16 s16 a'16 s16 d'16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "3'12\"" } s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "3'20\"" }  \override Staff.Stem #'transparent = ##f e''16 \harmonic  _1  [  d'16 \harmonic  f'16 \harmonic  r16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "3'24\"" } s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } f'16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 a'16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "3'36\"" } s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "3'48\"" } s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 s16 s16 a'16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 \bracketify d'16 s16 s16 s16 d'16 s16 s16 s16 s16 s16 s16 s16 d'16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 d'16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "4'00\"" } s16 s16 s16 s16 d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 f'16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "4'08\"" }  \override Staff.Stem #'transparent = ##f a'16  _3  [ r16 r16 \xNote c''16  _1  ] \xNote d'16  [ \xNote a'16 \xNote c''16 e''16  _3  ] r16  [ r16 f'16 \harmonic  _1  a'16 \harmonic   ] e''16  [ d'16 \harmonic  f'16 \harmonic  r16  ] r16  [ r16 r16 r16  ]  \bar "||"  \mark \markup{ \fontsize #-2 "4'12\"" }  \override Staff.Stem #'transparent = ##t c''16 s16 a'16 s16 s16 s16 a'16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "4'24\"" } s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 c''16 s16 s16 s16 a'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 c''16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "4'36\"" } c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16 f'16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } d'16 s16 s16 s16 a'16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "4'48\"" }  \override Staff.Stem #'transparent = ##f c''16  _1  [ \xNote d'16 \xNote a'16 \xNote e''16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t f'16 s16 s16 s16 s16 s16 s16 s16 \bracketify d'16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16  \mark \markup{ \fontsize #-2 "5'00\"" } s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "5'04\"" }  \override Staff.Stem #'transparent = ##f d'16 \harmonic  _1  [  f'16 r16 r16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "5'12\"" } s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16  \mark \markup{ \fontsize #-2 "5'24\"" } s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "5'36\"" } s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 a'16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "5'44\"" }  \override Staff.Stem #'transparent = ##f \xNote c''16  _1  [ \xNote e''16 \xNote g''16 \xNote f'16  ] \xNote c''16  [ g''16 \harmonic  _2  r16 d'16 \harmonic   ] r16  [ a'16 \harmonic  _1  c''16 e''16  ] d'16 \harmonic  _3  [  r16 r16 a'16 \harmonic  _1   ] c''16  _3  [ r16 r16 g''16  ]  \mark \markup{ \fontsize #-2 "5'48\"" } r16  [ r16 d'16  _2 r16  ] a'16 \harmonic  [  r16 \xNote c''16  _1 g''16 \harmonic  _2   ] r16  [ a'16 r16 \xNote c''16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } d'16 s16 s16 s16 f'16 s16 s16 s16 \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "6'00\"" } s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 f'16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 c''16 s16 a'16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "6'12\"" } a'16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16 a'16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "6'16\"" }  \override Staff.Stem #'transparent = ##f \xNote g''16  _1  [ d'16 \harmonic  _2  r16 c''16  ] r16  [ g''16 r16 f'16  _1  ] a'16  _2  [ r16 c''16 \harmonic  r16  ] e''16 \harmonic  [  r16 \xNote g''16  _1 \xNote d'16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16  \mark \markup{ \fontsize #-2 "6'24\"" } s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 s16 s16  \mark \markup{ \fontsize #-2 "6'36\"" } s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } d'16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } d'16 s16 s16 s16 a'16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "6'48\"" }  \override Staff.Stem #'transparent = ##f a'16  _3  [ r16 r16 c''16  _2  ] r16  [ e''16 r16 \xNote d'16  _1  ] f'16 \harmonic  _3  [  r16 r16 e''16 \harmonic   ] r16  [ r16 d'16 \harmonic  _1  f'16 \harmonic   ] \xNote c''16  [ \xNote e''16 d'16 \harmonic  f'16 \harmonic   ] c''16 \harmonic  [  e''16 \harmonic  g''16 \harmonic  _2  r16  ] f'16 \harmonic  [  r16 a'16  _3 r16  ] r16  [ g''16 r16 r16  ] \xNote f'16  _1  [ \xNote e''16 d'16 \harmonic  _2  r16  ] f'16 \harmonic  [  r16 a'16 \harmonic  _3  r16  ] r16  [ c''16 \harmonic  r16 r16  ] g''16  _2  [ r16 \xNote d'16  _1 \xNote f'16  ] a'16 \harmonic  [  e''16 \harmonic  d'16 \harmonic  _2  r16  ] f'16 \harmonic  [  r16 \xNote a'16  _1 e''16  _3  ] r16  [ r16 \xNote d'16  _1 \xNote c''16  ]  \mark \markup{ \fontsize #-2 "7'00\"" } g''16  _2  [ r16 \xNote d'16  _1 \xNote f'16  ] a'16  _2  [ r16 \xNote c''16  _1 \xNote e''16  ] d'16 \harmonic  _3  [  r16 r16 f'16  ] r16  [ r16 a'16  _1 \xNote e''16  ] g''16  [ f'16 c''16 \harmonic  g''16  ] d'16  [ c''16 \harmonic  g''16 \harmonic  _3  r16  ] r16  [ f'16  _2 r16 e''16 \harmonic   ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 d'16 s16 f'16 s16 s16 s16  \mark \markup{ \fontsize #-2 "7'12\"" } a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "7'24\"" } s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "7'36\"" }  \override Staff.Stem #'transparent = ##f d'16 \harmonic  _2  [  r16 a'16 \harmonic  r16  ] e''16  _3  [ r16 r16 g''16 \harmonic   ] r16  [ r16 d'16 \harmonic  _2  r16  ] f'16 \harmonic  [  r16 a'16 \harmonic  _3  r16  ] r16  [ c''16 \harmonic  r16 r16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16  \mark \markup{ \fontsize #-2 "7'48\"" } s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 a'16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16 f'16 s16 a'16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "7'56\"" }  \override Staff.Stem #'transparent = ##f g''16 \harmonic  _3  [  r16 r16 d'16 \harmonic   ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "8'00\"" } a'16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16 s16 s16 a'16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "8'12\"" }  \override Staff.Stem #'transparent = ##f f'16 \harmonic  _3  [  r16 r16 \xNote c''16  _1  ] g''16 \harmonic  _3  [  r16 r16 d'16 \harmonic  _1   ] c''16 \harmonic  [  e''16  _3 r16 r16  ] \xNote g''16  _1  [ \xNote d'16 a'16 r16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "8'24\"" } s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "8'36\"" } s16 s16 c''16 s16 a'16 s16 c''16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "8'40\"" }  \override Staff.Stem #'transparent = ##f \xNote g''16  _1  [ a'16  _2 r16 e''16  _1  ] g''16  _3  [ r16 r16 d'16 \harmonic   ] r16  [ r16 c''16 r16  ] r16  [ g''16  _1 d'16 a'16 \harmonic   ] c''16 \harmonic  [  \xNote d'16 f'16 \xNote e''16  ] g''16  [ d'16 \harmonic  _2  r16 \xNote f'16  _1  ] c''16  _2  [ r16 e''16 r16  ] g''16 \harmonic  _1  [  d'16  _3 r16 r16  ] f'16  [ r16 r16 a'16  ] r16  [ r16 e''16 r16  ]  \mark \markup{ \fontsize #-2 "8'48\"" } r16  [ d'16 \harmonic  r16 r16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 f'16 s16 f'16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 a'16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16  \mark \markup{ \fontsize #-2 "9'00\"" } \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 a'16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "9'04\"" }  \override Staff.Stem #'transparent = ##f a'16 \harmonic  _1  [  c''16 \harmonic  e''16 \harmonic  d'16  _3  ] r16  [ r16 \xNote a'16  _1 \xNote e''16  ] \xNote g''16  [ \xNote f'16 c''16 \harmonic  \xNote e''16  ] f'16  [ e''16 \harmonic  d'16 \harmonic  _2  r16  ] a'16  [ r16 g''16 \harmonic  r16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \bracketify d'16 s16 s16 s16  \mark \markup{ \fontsize #-2 "9'12\"" } s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 d'16 s16  \mark \markup{ \fontsize #-2 "9'24\"" } s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "9'36\"" } s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "9'44\"" }  \override Staff.Stem #'transparent = ##f a'16 \harmonic  _3  [  r16 r16 \xNote c''16  _1  ] \xNote g''16  [ d'16 \harmonic  _2  r16 f'16 \harmonic   ] r16  [ c''16 \harmonic  r16 \xNote e''16  _1  ] \xNote g''16  [ d'16 a'16 \harmonic  e''16 \harmonic   ] \xNote d'16  [ \xNote f'16 e''16 \xNote g''16  ]  \mark \markup{ \fontsize #-2 "9'48\"" } \xNote d'16  [ a'16 \harmonic  c''16 \harmonic  d'16 \harmonic   ] a'16  [ g''16 f'16 c''16  ] e''16  _2  [ r16 \xNote f'16  _1 \xNote e''16  ] f'16 \harmonic  _2  [  r16 e''16 \harmonic  _3  r16  ] r16  [ d'16 \harmonic  _2  r16 \xNote a'16  _1  ] e''16 \harmonic  _3  [  r16 r16 d'16  ] r16  [ r16 f'16  _2 r16  ] a'16 \harmonic  [  r16 c''16 \harmonic  r16  ] e''16 \harmonic  [  r16 d'16 r16  ] f'16 \harmonic  [  r16 \xNote c''16  _1 e''16  _2  ] r16  [ \xNote d'16  _1 \xNote f'16 \xNote c''16  ] \xNote d'16  [ \xNote f'16 \xNote e''16 \xNote f'16  ] c''16 \harmonic  _2  [  r16 e''16 r16  ] d'16  [ r16 a'16 r16  ] c''16 \harmonic  _3  [  r16 r16 e''16 \harmonic  _2   ]  \mark \markup{ \fontsize #-2 "10'00\"" } r16  [ \xNote g''16  _1 f'16  _2 r16  ] a'16 \harmonic  [  r16 g''16 \harmonic  r16  ] f'16  [ r16 c''16 r16  ] d'16 \harmonic  [  r16 a'16 r16  ] c''16  _1  [ e''16  _3 r16 r16  ] \xNote d'16  _1  [ \xNote c''16 e''16  _3 r16  ] r16  [ \xNote g''16  _1 d'16  _2 r16  ] a'16 \harmonic  _1  [  \xNote c''16 \xNote g''16 \xNote a'16  ] \xNote g''16  [ \xNote f'16 a'16 \harmonic  _3  r16  ] r16  [ c''16 \harmonic  r16 r16  ] g''16 \harmonic  [  r16 r16 d'16 \harmonic   ] r16  [ r16 c''16 \harmonic  r16  ] r16  [ d'16 \harmonic  r16 r16  ] c''16  [ r16 r16 d'16  ] r16  [ r16 \xNote a'16  _1 \xNote c''16  ]  \mark \markup{ \fontsize #-2 "10'12\"" } e''16 \harmonic  _2  [  r16 d'16 \harmonic  _3  r16  ] r16  [ a'16 \harmonic  r16 r16  ] g''16 \harmonic  [  r16 r16 f'16 \harmonic   ] r16  [ r16 a'16 \harmonic  r16  ] r16  [ c''16 \harmonic  r16 r16  ] \xNote e''16  _1  [ g''16 \xNote f'16 a'16 \harmonic  _3   ] r16  [ r16 \xNote c''16  _1 e''16 \harmonic  _3   ] r16  [ r16 g''16 \harmonic  r16  ] r16  [ d'16 \harmonic  r16 r16  ] c''16 \harmonic  [  r16 r16 g''16  _1  ] \xNote f'16  [ c''16  _2 r16 d'16 \harmonic   ] r16  [ f'16  _1 \xNote a'16 c''16 \harmonic  _3   ] r16  [ r16 g''16 \harmonic  r16  ] r16  [ a'16 \harmonic  _2  r16 \xNote c''16  ] r16  [ r16 r16 r16  ]  \bar "||"  \mark \markup{ \fontsize #-2 "10'24\"" }  \override Staff.Stem #'transparent = ##t c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 a'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 a'16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "10'32\"" }  \override Staff.Stem #'transparent = ##f g''16  _2  [ r16 \xNote d'16  _1 \xNote c''16  ] e''16  _2  [ r16 g''16 r16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } f'16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "10'36\"" } s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "10'40\"" }  \override Staff.Stem #'transparent = ##f d'16  _2  [ r16 a'16 r16  ] c''16  [ r16 g''16 r16  ] \xNote d'16  _1  [ \xNote f'16 a'16 \harmonic  _2  r16  ] c''16 \harmonic  [  r16 e''16 \harmonic  _3  r16  ] r16  [ g''16 \harmonic  r16 r16  ] a'16 \harmonic  _2  [  r16 g''16 \harmonic  r16  ] f'16 \harmonic  _3  [  r16 r16 a'16 \harmonic   ] r16  [ r16 c''16 \harmonic  r16  ] r16  [ e''16 r16 r16  ] f'16  [ r16 r16 a'16  _1  ]  \mark \markup{ \fontsize #-2 "10'48\"" } c''16  [ e''16 \harmonic  _3  r16 r16  ] \xNote g''16  _1  [ a'16 \harmonic  _2  r16 c''16 \harmonic   ] r16  [ e''16 \harmonic  _3  r16 r16  ] d'16 \harmonic  _1  [  \xNote f'16 \xNote e''16 f'16  ] \xNote a'16  [ \xNote e''16 \xNote g''16 \xNote d'16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "11'00\"" } s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 f'16 s16 s16 s16 s16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "11'04\"" }  \override Staff.Stem #'transparent = ##f \xNote f'16  _1  [ \xNote e''16 g''16 \harmonic  _3  r16  ] r16  [ f'16 \harmonic  r16 r16  ] \xNote c''16  _1  [ \xNote d'16 \xNote a'16 \xNote g''16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "11'12\"" }  \override Staff.Stem #'transparent = ##f \xNote d'16  _1  [ \xNote f'16 \xNote c''16 \xNote d'16  ] \xNote f'16  [ \xNote e''16 d'16 r16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 d'16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "11'24\"" }  \override Staff.Stem #'transparent = ##f f'16  _2  [ r16 a'16 r16  ] c''16  _1  [ \xNote d'16 c''16 \harmonic  _3  r16  ] r16  [ e''16  _2 r16 d'16  _3  ] r16  [ r16 a'16 r16  ] r16  [ e''16  _2 r16 f'16  _1  ] e''16  _3  [ r16 r16 \xNote g''16  _1  ] \xNote d'16  [ f'16 \harmonic  _2  r16 a'16 \harmonic   ] r16  [ \xNote e''16  _1 \xNote f'16 \xNote e''16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 c''16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16 s16 s16 c''16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "11'36\"" }  \override Staff.Stem #'transparent = ##f \xNote d'16  _1  [ c''16 \harmonic  _2  r16 e''16 \harmonic   ] r16  [ \xNote g''16  _1 \xNote f'16 a'16 \harmonic   ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 c''16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "11'44\"" }  \override Staff.Stem #'transparent = ##f e''16 \harmonic  _1  [  g''16 \xNote d'16 \xNote f'16  ] c''16 \harmonic  _3  [  r16 r16 e''16 \harmonic   ] r16  [ r16 g''16 \harmonic  _1  d'16 \harmonic   ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 s16 s16  \mark \markup{ \fontsize #-2 "11'48\"" } s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 \bracketify d'16 s16 s16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "12'00\"" }  \override Staff.Stem #'transparent = ##f a'16 \harmonic  _1  [  g''16 \harmonic  _2  r16 \xNote d'16  _1  ] f'16 \harmonic  [  \xNote c''16 g''16  _2 r16  ] \xNote d'16  _1  [ f'16 \harmonic  a'16 \harmonic  _2  r16  ] \xNote c''16  _1  [ \xNote g''16 \xNote f'16 \xNote c''16  ] \xNote d'16  [ a'16 \harmonic  \xNote e''16 g''16  _2  ] r16  [ a'16 r16 g''16 \harmonic   ] r16  [ d'16 \harmonic  r16 f'16 \harmonic   ] r16  [ a'16 \harmonic  r16 c''16 \harmonic   ] r16  [ e''16 \harmonic  r16 g''16  ] r16  [ d'16 r16 \xNote f'16  _1  ] a'16  [ c''16  _2 r16 e''16 \harmonic   ] r16  [ g''16 \harmonic  r16 a'16 \harmonic   ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t f'16 s16 a'16 s16 s16 s16 f'16 s16  \mark \markup{ \fontsize #-2 "12'12\"" } s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "12'24\"" }  \override Staff.Stem #'transparent = ##f e''16  _2  [ r16 g''16 r16  ] f'16  _1  [ a'16 c''16 e''16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 c''16 s16 s16 s16 a'16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "12'36\"" }  \override Staff.Stem #'transparent = ##f f'16 \harmonic  _3  [  r16 r16 \xNote c''16  _1  ] \xNote g''16  [ \xNote f'16 \xNote a'16 e''16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "12'48\"" }  \override Staff.Stem #'transparent = ##f g''16 \harmonic  _2  [  r16 d'16 \harmonic  r16  ] a'16 \harmonic  [  r16 g''16 \harmonic  _3  r16  ] r16  [ d'16 \harmonic  r16 r16  ] f'16 \harmonic  [  r16 r16 a'16 \harmonic   ] r16  [ r16 c''16 r16  ] r16  [ g''16 r16 r16  ] a'16 \harmonic  [  r16 r16 e''16 \harmonic   ] r16  [ r16 d'16  _1 c''16  ] e''16  _2  [ r16 \xNote g''16  _1 \xNote d'16  ] \xNote a'16  [ \xNote c''16 e''16  _3 r16  ] r16  [ d'16 \harmonic  r16 r16  ] \xNote f'16  _1  [ e''16 d'16 \harmonic  f'16 \harmonic  _3   ] r16  [ r16 c''16 r16  ] r16  [ \xNote e''16  _1 \xNote g''16 a'16  _3  ] r16  [ r16 c''16 r16  ]  \mark \markup{ \fontsize #-2 "13'00\"" } r16  [ d'16 \harmonic  _2  r16 a'16 \harmonic  _1   ] g''16 \harmonic  _3  [  r16 r16 d'16 \harmonic   ] r16  [ r16 a'16 \harmonic  r16  ] r16  [ \xNote e''16  _1 \xNote d'16 \xNote a'16  ] e''16 \harmonic  _3  [  r16 r16 g''16  _1  ] d'16  [ c''16 e''16 \harmonic  f'16 \harmonic  _3   ] r16  [ r16 c''16 \harmonic  r16  ] r16  [ e''16 \harmonic  _1  d'16 \harmonic  _2  r16  ] \xNote a'16  _1  [ \xNote g''16 \xNote d'16 f'16 \harmonic   ] \xNote a'16  [ \xNote c''16 d'16 \harmonic  a'16  _3  ] r16  [ r16 e''16 r16  ] r16  [ \xNote d'16  _1 \xNote c''16 \xNote e''16  ] \xNote g''16  [ \xNote f'16 \xNote c''16 \xNote d'16  ] \xNote a'16  [ \xNote c''16 \xNote e''16 \xNote d'16  ] f'16  _2  [ r16 a'16  _3 r16  ]  \mark \markup{ \fontsize #-2 "13'12\"" } r16  [ c''16 \harmonic  r16 r16  ] \xNote g''16  _1  [ \xNote d'16 \xNote f'16 \xNote a'16  ] \xNote c''16  [ e''16 \harmonic  d'16 \harmonic  f'16 \harmonic  _3   ] r16  [ r16 a'16 \harmonic  _1  c''16 \harmonic  _2   ] r16  [ e''16  _1 f'16 \harmonic  e''16 \harmonic   ] \xNote g''16  [ d'16 a'16 c''16 \harmonic   ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 s16 s16 a'16 s16 f'16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "13'24\"" }  \override Staff.Stem #'transparent = ##f e''16 \harmonic  _1  [  d'16 \harmonic  f'16 \harmonic  c''16 \harmonic   ] e''16 \harmonic  [  f'16  _3 r16 r16  ] a'16 \harmonic  _1  [  c''16 g''16 \xNote d'16  ] a'16  _3  [ r16 r16 \xNote c''16  _1  ] g''16 \harmonic  _2  [  r16 \xNote d'16  _1 \xNote a'16  ] \xNote c''16  [ \xNote e''16 \xNote g''16 \xNote a'16  ] \xNote e''16  [ \xNote d'16 \xNote f'16 \xNote a'16  ] e''16  _3  [ r16 r16 d'16  _2  ] r16  [ \xNote a'16  _1 e''16 \harmonic  _2  r16  ] \xNote g''16  _1  [ f'16 \harmonic  _2  r16 c''16  ] r16  [ \xNote e''16  _1 \xNote g''16 \xNote d'16  ] \xNote f'16  [ \xNote c''16 d'16  _3 r16  ] r16  [ f'16 r16 r16  ] a'16  _2  [ r16 c''16 \harmonic  r16  ] e''16  [ r16 d'16 r16  ]  \mark \markup{ \fontsize #-2 "13'36\"" } c''16  _3  [ r16 r16 g''16  ] r16  [ r16 f'16 r16  ] r16  [ a'16 r16 r16  ] e''16 \harmonic  [  r16 r16 f'16  ] r16  [ r16 c''16  _2 r16  ] d'16 \harmonic  _1  [  \xNote f'16 a'16 \harmonic  \xNote c''16  ] \xNote g''16  [ d'16  _2 r16 \xNote f'16  _1  ] c''16 \harmonic  _3  [  r16 r16 e''16 \harmonic  _2   ] r16  [ g''16  _1 d'16 c''16  ] e''16 \harmonic  [  g''16 f'16 a'16  ] c''16 \harmonic  [  e''16 \harmonic  f'16 \harmonic  \xNote c''16  ] \xNote d'16  [ f'16 \harmonic  a'16 \harmonic  g''16  ] f'16 \harmonic  [  a'16 c''16  _2 r16  ] e''16  [ r16 d'16 r16  ] c''16 \harmonic  [  r16 g''16 \harmonic  r16  ]  \mark \markup{ \fontsize #-2 "13'48\"" } d'16  [ r16 a'16 \harmonic  r16  ] \xNote g''16  _1  [ \xNote d'16 \xNote a'16 \xNote e''16  ] g''16 \harmonic  _2  [  r16 d'16 \harmonic  r16  ] a'16  [ r16 e''16 r16  ] f'16  [ r16 c''16 \harmonic  r16  ] g''16 \harmonic  [  r16 \xNote a'16  _1 c''16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 a'16 s16 f'16 s16 a'16 s16  \mark \markup{ \fontsize #-2 "14'00\"" } f'16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "14'12\"" }  \override Staff.Stem #'transparent = ##f d'16 \harmonic  _2  [  r16 f'16 \harmonic  _1  e''16 \harmonic   ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \bracketify d'16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 a'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify f'16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "14'20\"" }  \override Staff.Stem #'transparent = ##f d'16 \harmonic  _3  [  r16 r16 f'16 \harmonic  _2   ] r16  [ c''16 \harmonic  _3  r16 r16  ] e''16 \harmonic  [  r16 r16 \xNote g''16  _1  ] \xNote f'16  [ a'16 \harmonic  c''16 \xNote e''16  ] g''16 \harmonic  [  \xNote d'16 f'16  _2 r16  ]  \mark \markup{ \fontsize #-2 "14'24\"" } c''16  [ r16 \xNote e''16  _1 g''16  _3  ] r16  [ r16 a'16 r16  ] r16  [ c''16 r16 r16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t a'16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16  \mark \markup{ \fontsize #-2 "14'36\"" } s16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 c''16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify f'16 s16 s16 s16 s16 s16 s16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "14'44\"" }  \override Staff.Stem #'transparent = ##f e''16  _3  [ r16 r16 d'16  ] r16  [ r16 f'16  _1 \xNote c''16  ] \xNote e''16  [ g''16 \harmonic  d'16  _2 r16  ] a'16  [ r16 c''16 \harmonic  _3  r16  ] r16  [ g''16 \harmonic  _1  \xNote a'16 c''16 \harmonic  _2   ]  \mark \markup{ \fontsize #-2 "14'48\"" } r16  [ \xNote d'16  _1 \xNote a'16 g''16  _2  ] r16  [ \xNote d'16  _1 a'16 \harmonic  e''16 \harmonic  _2   ] r16  [ f'16 \harmonic  _3  r16 r16  ] c''16 \harmonic  [  r16 r16 e''16 \harmonic   ] r16  [ r16 g''16 \harmonic  _2  r16  ] f'16 \harmonic  _3  [  r16 r16 c''16 \harmonic   ] r16  [ r16 g''16 \harmonic  r16  ] r16  [ d'16  _1 a'16 g''16  ] d'16  [ f'16  _2 r16 c''16 \harmonic   ] r16  [ \xNote e''16  _1 \xNote d'16 f'16  _2  ] r16  [ c''16 r16 e''16 \harmonic  _3   ] r16  [ r16 g''16  _2 r16  ] a'16  [ r16 c''16  _1 e''16  ] \xNote f'16  [ \xNote a'16 \xNote c''16 \xNote g''16  ] a'16  [ e''16 f'16 a'16  ]  \mark \markup{ \fontsize #-2 "15'00\"" } e''16  _3  [ r16 r16 g''16  ] r16  [ r16 f'16  _2 r16  ] a'16 \harmonic  [  r16 c''16 \harmonic  _1  g''16 \harmonic  _2   ] r16  [ \xNote d'16  _1 f'16 \harmonic  _2  r16  ] e''16 \harmonic  [  r16 d'16 \harmonic  _3  r16  ] r16  [ f'16 \harmonic  r16 r16  ] e''16 \harmonic  [  r16 r16 g''16 \harmonic   ] r16  [ r16 d'16 \harmonic  _1  f'16 \harmonic   ] c''16 \harmonic  [  e''16 \harmonic  _3  r16 r16  ] g''16 \harmonic  _2  [  r16 a'16 \harmonic  r16  ] \xNote g''16  _1  [ \xNote d'16 f'16 \harmonic  c''16 \harmonic   ] e''16  [ g''16 \harmonic  a'16 \harmonic  c''16 \harmonic  _3   ] r16  [ r16 g''16 \harmonic  r16  ] r16  [ a'16 \harmonic  r16 r16  ] e''16 \harmonic  _2  [  r16 f'16 r16  ]  \mark \markup{ \fontsize #-2 "15'12\"" } a'16  _3  [ r16 r16 c''16 \harmonic   ] r16  [ r16 d'16 \harmonic  r16  ] r16  [ f'16 \harmonic  r16 r16  ] a'16 \harmonic  [  r16 r16 g''16 \harmonic   ] r16  [ r16 \xNote d'16  _1 \xNote f'16  ] \xNote c''16  [ \xNote d'16 f'16  _2 r16  ] a'16  [ r16 c''16 \harmonic  _1  g''16 \harmonic   ] \xNote f'16  [ c''16 \harmonic  _3  r16 r16  ] e''16 \harmonic  _2  [  r16 f'16 \harmonic  _3  r16  ] r16  [ e''16 \harmonic  _2  r16 d'16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t c''16 s16 s16 s16 a'16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } \bracketify f'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "1" } f'16 s16  \bar "||"  \mark \markup{ \fontsize #-2 "15'24\"" }  \override Staff.Stem #'transparent = ##f f'16  _2  [ r16 e''16 \harmonic  r16  ] d'16 \harmonic  [  r16 f'16 \harmonic  _1  a'16 \harmonic   ] c''16 \harmonic  [  g''16 \harmonic  _2  r16 a'16 \harmonic   ] r16  [ c''16 r16 e''16  _1  ] g''16  [ \xNote d'16 a'16  _2 r16  ] g''16  [ r16 \xNote f'16  _1 \xNote c''16  ] g''16 \harmonic  [  d'16 \harmonic  _3  r16 r16  ] f'16 \harmonic  _1  [  a'16 \harmonic  _2  r16 c''16 \harmonic   ] r16  [ e''16 \harmonic  _1  d'16 \xNote f'16  ] \xNote a'16  [ \xNote g''16 \xNote d'16 \xNote f'16  ] a'16 \harmonic  [  c''16 \harmonic  \xNote e''16 \xNote g''16  ] r16  [ r16 r16 r16  ]  \bar "||"  \override Staff.Stem #'transparent = ##t c''16 s16 a'16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "3" } \bracketify d'16 s16  \mark \markup{ \fontsize #-2 "15'36\"" } s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 f'16 s16 a'16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } \bracketify d'16 s16 a'16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 \once \override NoteHead #'stencil = #ly:text-interface::print \once \override NoteHead #'text = \markup { \translate #'(-0 . -0.8) \whiteout \pad-markup #0.5 "2" } d'16 s16 s16 s16 s16 s16 f'16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 s16 \bracketify d'16 s16  \bar "|." } >>
  >>
}